Version 1.00
BEGIN Form InterfaceWindow
	AutoRedraw   = 0
	BackColor    = QBColor(7)
	BorderStyle  = 2
	Caption      = "DOSPad"
	ControlBox   = -1
	Enabled      = -1
	ForeColor    = QBColor(0)
	Height       = Char(17)
	Left         = Char(15)
	MaxButton    = -1
	MinButton    = -1
	MousePointer = 0
	Tag          = ""
	Top          = Char(3)
	Visible      = -1
	Width        = Char(63)
	WindowState  = 0
	BEGIN TextBox TextBox
		BackColor    = QBColor(7)
		BorderStyle  = 1
		DragMode     = 0
		Enabled      = -1
		ForeColor    = QBColor(0)
		Height       = Char(12)
		Left         = Char(0)
		MousePointer = 0
		MultiLine    = -1
		ScrollBars   = 3
		TabIndex     = 0
		TabStop      = -1
		Tag          = ""
		Text         = ""
		Top          = Char(0)
		Visible      = -1
		Width        = Char(49)
	END
	BEGIN Menu FileMain
		Caption      = "&File"
		Checked      = 0
		Enabled      = -1
		Separator    = 0
		Tag          = ""
		Visible      = -1
		BEGIN Menu FileNewMenu
			Caption      = "&New"
			Checked      = 0
			Enabled      = -1
			Separator    = 0
			Shortcut     = ^N
			Tag          = ""
			Visible      = -1
		END
		BEGIN Menu FileOpenMenu
			Caption      = "&Open"
			Checked      = 0
			Enabled      = -1
			Separator    = 0
			Shortcut     = ^O
			Tag          = ""
			Visible      = -1
		END
		BEGIN Menu FileSaveMenu
			Caption      = "&Save"
			Checked      = 0
			Enabled      = -1
			Separator    = 0
			Shortcut     = ^S
			Tag          = ""
			Visible      = -1
		END
		BEGIN Menu FileMenuSeparator1
			Caption      = ""
			Checked      = 0
			Enabled      = -1
			Separator    = -1
			Tag          = ""
			Visible      = -1
		END
		BEGIN Menu FilePrintMenu
			Caption      = "&Print"
			Checked      = 0
			Enabled      = -1
			Separator    = 0
			Shortcut     = ^P
			Tag          = ""
			Visible      = -1
		END
		BEGIN Menu FileMenuSeparator2
			Caption      = ""
			Checked      = 0
			Enabled      = -1
			Separator    = -1
			Tag          = ""
			Visible      = -1
		END
		BEGIN Menu FileExitMenu
			Caption      = "&Exit"
			Checked      = 0
			Enabled      = -1
			Separator    = 0
			Shortcut     = ^X
			Tag          = ""
			Visible      = -1
		END
	END
	BEGIN Menu EditMainMenu
		Caption      = "&Edit"
		Checked      = 0
		Enabled      = -1
		Separator    = 0
		Tag          = ""
		Visible      = -1
		BEGIN Menu EditCopyMenu
			Caption      = "&Copy"
			Checked      = 0
			Enabled      = -1
			Separator    = 0
			Shortcut     = ^C
			Tag          = ""
			Visible      = -1
		END
		BEGIN Menu EditPasteMenu
			Caption      = "&Paste"
			Checked      = 0
			Enabled      = -1
			Separator    = 0
			Shortcut     = ^V
			Tag          = ""
			Visible      = -1
		END
	END
	BEGIN Menu AboutMainMenu
		Caption      = "&About"
		Checked      = 0
		Enabled      = -1
		Separator    = 0
		Tag          = ""
		Visible      = -1
	END
END
'$INCLUDE: 'CMNDLG.BI'
'$INCLUDE: 'CONSTANT.BI'
DEFINT A-Z
OPTION EXPLICIT

CONST EXTENSION$ = ".txt"

DECLARE FUNCTION BuildPath (FilePath AS STRING, FileName AS STRING, FileExtension AS STRING) AS STRING
DECLARE FUNCTION LoadFile (FileName AS STRING) AS STRING
DECLARE SUB SaveFile (FileName AS STRING, Text AS STRING)

SUB AboutMainMenu_Click ()
 MSGBOX "DOSPad v1.00 - By: Peter Swinkels, ***2024***", MB_OK
END SUB

SUB EditCopyMenu_Click ()
 ClipBoard.SETTEXT MID$(TextBox.Text, TextBox.SelStart + 1, TextBox.SelLength)
END SUB

SUB EditPasteMenu_Click ()
DIM Position AS INTEGER

 Position = TextBox.SelStart
 TextBox.Text = LEFT$(TextBox.Text, Position + 1) + ClipBoard.GETTEXT() + MID$(TextBox.Text, Position + TextBox.SelLength + 1)
 IF Position < LEN(TextBox.Text) THEN TextBox.SelStart = Position
END SUB

SUB FileExitMenu_Click ()
 UNLOAD InterfaceWindow
END SUB

SUB FileNewMenu_Click ()
 IF MSGBOX("Do you want to start a new document?", MB_YESNO OR MB_DEFBUTTON2) = IDYES THEN
  TextBox.Text = ""
 END IF
END SUB

SUB FileOpenMenu_Click ()
DIM Cancel AS INTEGER
DIM FileName AS STRING
DIM FilePath AS STRING

 FilePath = CURDIR$
 FileOpen FileName, FilePath, "*" + EXTENSION$, "Open file.", CINT(InterfaceWindow.ForeColor), CINT(InterfaceWindow.BackColor), 0, Cancel
 IF NOT Cancel THEN
  TextBox.Text = LoadFile(BuildPath(FilePath, FileName, EXTENSION$))
 END IF
END SUB

SUB FilePrintMenu_Click ()
DIM Cancel AS INTEGER
DIM CopyCount AS INTEGER

 FilePrint CopyCount, CINT(InterfaceWindow.ForeColor), CINT(InterfaceWindow.BackColor), Cancel
 IF NOT Cancel THEN
  Printer.PRINT TextBox.Text
  Printer.ENDDOC
 END IF
END SUB

SUB FileSaveMenu_Click ()
DIM Cancel AS INTEGER
DIM FileName AS STRING
DIM FilePath AS STRING

 FilePath = CURDIR$
 FileSave FileName, FilePath, "*" + EXTENSION$, "Save file.", CINT(InterfaceWindow.ForeColor), CINT(InterfaceWindow.BackColor), 0, Cancel
 IF NOT Cancel THEN
  SaveFile BuildPath(FilePath, FileName, EXTENSION$), (TextBox.Text)
 END IF
END SUB

DEFSNG A-Z
SUB Form_Load ()
 InterfaceWindow.Width = Screen.Width / 2
 InterfaceWindow.Height = Screen.Height / 2
 InterfaceWindow.Left = (Screen.Width / 2) - (InterfaceWindow.Width / 2)
 InterfaceWindow.Top = (Screen.Height / 2) - (InterfaceWindow.Height / 2)
 InterfaceWindow.WindowState = MAXIMIZED

END SUB

DEFINT A-Z
SUB Form_Resize ()
ON ERROR RESUME NEXT
 TextBox.Width = InterfaceWindow.ScaleWidth
 TextBox.Height = InterfaceWindow.ScaleHeight
END SUB

SUB Form_Unload (Cancel AS INTEGER)
 Cancel = (MSGBOX("Do you want to quit?", MB_YESNO OR MB_DEFBUTTON2) = IDNO)
END SUB

